
// dimensions
7 => int height;
4 => int width;
height * width => int dim;

// drum pal
[ 13, 12 ] @=> int pal[];

// strengths
[
  [ 0.0, 0.0, .0, 0.0, 0.0, 0.5, .7, 0.9 ],
  [ 1.0, .5, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 ]
] @=> float mygains[][];

int r, c;
int last_c;
int chan;
int which;
int doup;
float gain;

spork ~ up();

// infinite time loop
while( true )
{
    // synch
    X.synch => now;

    // look for every N pulse
    if( !(X.synch.col % 2)  )
    {
        X.synch.col / 2 => c;
        if( last_c > c ) // next row
        {
            !r => r;
            // <<< "play:", r >>>;
        }
        c => last_c;

        X.sliders[11] * 2.5 => gain;
        if( X.pads[1] > 0 )
            X.S.play( pal[r], -1, 
                  mygains[r][c]*X.pads[1]*gain, 1, 0 );
    }
}

// catch up stroke
fun void up()
{
    while( true )
    {
        // wait
        X.down[1] => now;
        // set flag
        0 => r;
        0 => last_c;
    }
}