// the ClicktyPlay class
public class ClicktyPlay extends Play
{
  // our patch
  SinOsc s => ADSR e => NRev r;
  .005 => r.mix;
  2.0 => s.gain;

  // set ADSR
  e.set( 5::ms, 5::ms, .5, 5::ms );

  // channels
  int which;

  // lame!
  Event event;

  // spork click shred
  spork ~ playit();

  // play
  fun void click( float start, float end )
  {
    // how long
    10::ms => dur howlong;
    // step
    100 => int steps;
    // increment
    (end - start) / steps => float inc;
    // time
    howlong / steps => dur dinc;
    // pitch
    start => float pitch;

    // key on
    e.keyOn();
    // go
    while( steps > 0 )
    {
        pitch + inc => pitch => Std.mtof => s.freq;
        steps--;
        dinc => now;
    }
    // key up
    e.keyOff();
    // wait
    5::ms => now;
  }

    // play
    fun void playit()
    {
        // infinite event loop
        while( true )
        {
            // wait
            event => now;
            if( !m_init ) return;

            // go
            click( Std.rand2(90,125), Std.rand2(50, 85) );
        }
    }


    // start
    fun void connect( UGen out )
    {
        // sever if needed
        if( m_init ) sever();
        r => out;
        out @=> m_out;
        true => m_init;
    }

    // stop
    fun void sever()
    { if( m_init ) { r =< m_out; false => m_init; } }

    // play
    fun void play( float vol, float pitch )
    {
        if( !m_init ) return;

        vol => e.gain;
        event.broadcast();
    }

    // set note
    fun float note( float note ) { return note; }
    // get note
    fun float note() { return 0.0; }

    // set volume
    fun float vol( float v ) { v => s.gain; return v; }
    // get volume
    fun float vol() { return s.gain(); }
}
