
// dimensions
7 => int height;
4 => int width;
height * width => int dim;

// drum pal
[ 5, 6, 10 ] @=> int pal[];

// strengths
[
  [ 0.0, 0.7, .9, 0.3, 0.7, 0.0, 0, 0.9,  0.0, 0.0, .0, 0.0, 0.0, 0.0, .0, 0.0 ],
[ 0.0, 0.7, .9, 0.3, 0.7, 0.0, 0, 0.8,  1.1, 0.0, .0, 0.0, 0.0, 0.0, .0, 0.0 ]
] @=> float mygains[][];

//instruments
[
  [ 0, 0, 1, 0, 1, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0 ],
  [ 0, 0, 1, 0, 1, 0, 0, 1, 2, 0, 0, 0, 0, 0, 0, 0 ]
] @=> int instr[][];

int r, c;
int last_c;
int chan;
int which;
int doup;
float gain;

spork ~ up();

// infinite time loop
while( true )
{
    // synch
    X.synch => now;

    // look for every N pulse
    if( !(X.synch.col % 1)  )
    {
        X.synch.col => c;
        if( last_c > c ) // next row
        {
            !r => r;
            // <<< "play:", r >>>;
        }
        c => last_c;

        X.sliders[11] * 2.5 => gain;
        if( X.pads[3] > 0 )
            X.S.play( pal[instr[r][c]], -1, 
                  mygains[r][c]*X.pads[3]*gain, 1, 0 );
    }
}

// catch up stroke
fun void up()
{
    while( true )
    {
        // wait
        X.down[3] => now;
        <<< "Dave (3)", "" >>>;
        // set flag
        0 => r;
        0 => last_c;
    }
}