// wet
adc.chan(0) => Gain mult => Gain wet => Gain out => dac;
Modulate e => Gain add => mult;
Step step => add;
// feedback
out => Gain feedback => DelayL delay => wet;
// munchkin orchestra
Gain munch => wet;

// dry
adc.chan(0) => Gain dry => dac;

// initial params
0 => step.next;
3 => mult.op;
12 => e.vibratoRate;
.5 => e.vibratoGain;

// 800::ms => delay.max => delay.delay;
X.T * 12 => delay.max => delay.delay;

// use three buffers
LiSa lisa[3];
.8::second => dur bufferlen;
0 => int recbuf;
2 => int playbuf;

// LiSa params
for( 0 => int i; i < 3; i++ )
{
    lisa[i].duration( bufferlen );
    lisa[i].maxVoices( 30 );
    lisa[i].clear();
    lisa[i].gain( 0.5 );
    lisa[i].feedback( 0.5 );
    lisa[i].recRamp( 20::ms );
    lisa[i].record( 0 );

    adc.chan(0) => lisa[i] => munch;
}

lisa[recbuf].record(1);

float v;
float mix;
fun void print()
{
  while( true )
  {
    <<< "feed:", feedback.gain(),
        "mix:", delay.gain(),
        "vibrate:", e.vibratoRate(),
        "vibgain:", e.vibratoGain(),
        "bias:", v,
        "munch:", munch.gain(),
        "dry/wet:", mix,
        "gain:", out.gain() >>>;

    200::ms => now;
  }
}

spork ~ print();
spork ~ munge();

// infinite event loop
while( true )
{
    X.sliders[0] => feedback.gain;
    X.sliders[1] => delay.gain;
    X.sliders[2] * 25 => e.vibratoRate;
    X.sliders[3] * 3 => e.vibratoGain;
    X.sliders[4] => step.next => v;
    X.sliders[6] => munch.gain;
    X.sliders[7] * 2 - 1 => mix;
    X.sliders[11] * 1.5 => out.gain;

    // set mix
    if( mix < 0 )
    {
        Math.fabs(mix) => dry.gain;
        0 => wet.gain;
    }
    else
    {
        mix => wet.gain;
        0 => dry.gain;
    }

    20::ms => now;
}

fun void munge()
{
  // create grains, rotate record and play bufs as needed
  // shouldn't click as long as the grainlen < bufferlen
  while(true)
  {
    now + bufferlen => time later;

    // toss some grains
    while( now < later )
    {
        Std.rand2f(0.5, 2.0) => float newrate;
        Std.rand2f(500, 800)::ms => dur newdur;

        // grain
        spork ~ getgrain(playbuf, newdur, 20::ms, 20::ms, newrate);
        // advance time
        10::ms => now;
    }

    // rotate the record and playbufs
    lisa[recbuf++].record( 0 );
    if( recbuf == 3 ) 0 => recbuf;
    lisa[recbuf].record( 1 );

    playbuf++;
    if( playbuf == 3 ) 0 => playbuf;
  }
}

// sporkee
fun void getgrain( int which, dur grainlen, dur rampup, dur rampdown, float rate )
{
    lisa[which].getVoice() => int newvoice;
    //<<<newvoice>>>;

    if(newvoice > -1)
    {
        lisa[which].rate(newvoice, rate);
        lisa[which].playPos(newvoice, Std.rand2f(0., 1.) * bufferlen);
        lisa[which].rampUp(newvoice, rampup);
        (grainlen - (rampup + rampdown)) => now;
        lisa[which].rampDown(newvoice, rampdown);
        rampdown => now;
    }
}

