FMVoices voi[4];
JCRev rev[4];
for( int i; i < voi.cap(); i++ )
{
    voi[i] => rev[i] => dac.chan( i % X.channels );
    .05 => rev[i].mix;
    0 => voi[i].gain;
}

// drone pitch
28 => Std.mtof => voi[0].freq;
36 => Std.mtof => voi[1].freq;
44 => Std.mtof => voi[2].freq;
50 => Std.mtof => voi[3].freq;

// device to open (see: chuck --probe)
0 => int device;

// midi event
MidiIn min;
// midi message
MidiMsg msg;

// open the midi device
if( !min.open( device ) ) me.exit();

// print out device that was opened
<<< "MIDI device:", min.num(), " -> ", min.name() >>>;

// infinite event loop
while( true )
{
    // wait for event
    min => now;

    // get the event(s)
    while( min.recv( msg ) )
    {
        // just for information
        // <<< msg.data1, msg.data2, msg.data3 >>>;

        // pads
        if( msg.data1 == 186 && msg.data2 >= 104 && msg.data2 < 108 )
        {
            msg.data3 / 128.0 => voi[msg.data2-104].gain;
        }
        else if( msg.data1 == 224 && msg.data2 == 0 )
        {
            .6 + msg.data3 / 128.0 * .4 => voi[msg.data2].vowel => float v;
            <<< "vowel:", v >>>;
        }
        // look for sliders
        else if( msg.data1 == 176 )
        {
            // vowel
            if( msg.data2 >= 1 && msg.data2 <= 1 )
            {
                .6 + msg.data3 / 128.0 * .4 => voi[msg.data2].vowel => float v;
                <<< "vowel:", v >>>;
            }
            if( msg.data2 >= 7 && msg.data2 <= 8 )
            {
                .6 + msg.data3 / 128.0 * .4 => voi[msg.data2-5].vowel => float v;
                <<< "vowel:", v >>>;
            }
            // modulate rate
            if( msg.data2 == 9 )
            {
              for( int i; i < voi.cap(); i++ )
                msg.data3 / 128.0 * 25 => voi[i].lfoSpeed;
                <<< "lfospeed:", voi[0].lfoSpeed() >>>;
            }
            // modulate gain
            else if( msg.data2 == 10 )
            {
              for( int i; i < voi.cap(); i++ )
                msg.data3 / 128.0 * 1 => voi[i].lfoDepth;
                <<< "lpfdepth:", voi[0].lfoDepth() >>>;
            }
            // overall gain
            else if( msg.data2 == 11 )
            {
                msg.data3 / 128.0 * 1.5 => dac.gain;
                <<< "gain:", dac.gain() >>>;
            }
            // overall gain
            else if( msg.data2 == 12 )
            {
msg.data3 / 128.0 => float g;
for( int i; i < voi.cap(); i++ )
{
    g => voi[i].gain;
}
                <<< "gain:", g >>>;
            }
        }
    }
}
