
// device to open (see: chuck --probe)
0 => int device;

// midi event
MidiIn min;
// midi message
MidiMsg msg;

// open the midi device
if( !min.open( device ) ) me.exit();

// print out device that was opened
<<< "MIDI device:", min.num(), " -> ", min.name() >>>;

// remap
int remap[128];
0 => remap[36];
1 => remap[38];
2 => remap[40];
3 => remap[41];
4 => remap[43];
5 => remap[45];
6 => remap[47];
7 => remap[48];
8 => remap[50];
9 => remap[52];
10 => remap[53];
11 => remap[55];
12 => remap[57];
13 => remap[59];
14 => remap[60];
15 => remap[62];

// infinite event loop
while( true )
{
    // wait for event
    min => now;

    // get the event(s)
    while( min.recv( msg ) )
    {
        // trigger
        if( msg.data1 == 144 )
        {
            if( msg.data3 != 0 )
                X.down[remap[msg.data2]].broadcast();
            else
                X.up[remap[msg.data2]].broadcast();
        }
        // look for sliders and aftertouch
        if( msg.data1 == 176 )
        {
            // pads
            if( msg.data2 >= 100 && msg.data2 <=115 )
                msg.data3 / 128.0 => X.pads[msg.data2-100];
            // sliders
            else if( msg.data2 >= 0 && msg.data2 <= 1 )
                msg.data3 / 128.0 => X.sliders[msg.data2];
            else if( msg.data2 >= 7 && msg.data2 <= 16 )
                msg.data3 / 128.0 => X.sliders[msg.data2-5];
        }
        if( msg.data1 == 224 && msg.data2 == 0 )
        {
            msg.data3 / 128.0 => X.sliders[0];
        }
    }
}
