// the ClicktyPlay class
public class SonOfClickty extends Play
{
  // our patch
  Noise n => TwoPole b => ADSR e => NRev r;
  .0005 => r.mix;
  2.0 => n.gain;

	b.freq(440);
	b.radius(.99);
	440. => float f;


  // set ADSR
  e.set( 5::ms, 5::ms, .5, 5::ms );

  // channels
  int which;

  // lame!
  Event event;

  // spork click shred
  spork ~ playit();

  // play
  fun void click( float start, float end )
  {

	//<<< "in click" >>>;
    // how long
    100::ms => dur howlong;
    // step
    100 => int steps;
    // increment
    (end - start) / steps => float inc;
    // time
    howlong / steps => dur dinc;
    // pitch
    f => b.freq;

    // key on
    e.keyOn();
    // go
    howlong => now;
    // key up
    e.keyOff();
    // wait
    5::ms => now;
  }

    // play
    fun void playit()
    {
        // infinite event loop
        while( true )
        {
            // wait
            event => now;
            if( !m_init ) return;

            // go
            click( Std.rand2(100,200), Std.rand2(50, 100) );
        }
    }


    // start
    fun void connect( UGen out )
    {
        // sever if needed
        if( m_init ) sever();
        r => out;
        out @=> m_out;
        true => m_init;
    }

    // stop
    fun void sever()
    { if( m_init ) { r =< m_out; false => m_init; } }

    // play
    fun void play( float v, float pitch )
    {
        if( !m_init ) return;
		 pitch => f;
		v => vol;
		<<<  f >>>;
        event.broadcast();
    }

    // set note
    fun float note( float note ) { return note; }
    // get note
    fun float note() { return 0.0; }

    // set volume
    fun float vol( float v ) { v => n.gain; return v; }
    // get volume
    fun float vol() { return n.gain(); }
}
