
// sound bank
public class SoundBank
{
    // actual channels
    6 => int channels;
    // sounds
    Play players[24];
    // load
    SoundPlay @ s;
    new SoundPlay @=> s @=> players[0];
    s.load( "../data/hit-1.wav" );
    new SoundPlay @=> s @=> players[1];
    s.load( "../data/hihat.wav" );
    new SoundPlay @=> s @=> players[2];
    s.load( "../data/kick-main.wav" );
    new SoundPlay @=> s @=> players[3];
    // s.load( "../data/gong-1.aif" );
    new SoundPlay @=> s @=> players[4];
    s.load( "../data/tabla_01.aiff" );
    new SoundPlay @=> s @=> players[5];
    s.load( "../data/tabla_09.aiff" );
    new SoundPlay @=> s @=> players[6];
    s.load( "../data/tabla_10.aiff" );
    new SoundPlay @=> s @=> players[7];
    s.load( "../data/tabla_11.aiff" );
    new SoundPlay @=> s @=> players[8];
    s.load( "../data/tabla_12.aiff" );
    new SoundPlay @=> s @=> players[9];
    s.load( "../data/tabla_19.aiff" );
    new SoundPlay @=> s @=> players[10];
    s.load( "../data/tabla_25.aiff" );
    new SoundPlay @=> s @=> players[11];
    s.load( "../data/tabla_26.aiff" );
    new SoundPlay @=> s @=> players[12];
    s.load( "../data/tabla_bahia_15.aiff" );
    new SoundPlay @=> s @=> players[13];
    s.load( "../data/tabla_01.aiff" );
    new SoundPlay @=> s @=> players[14];
    s.load( "../data/tabla_bahia_01.aiff" );
    new SoundPlay @=> s @=> players[15];
    // s.load( "../data/eraser_bass.wav" );
    new SoundPlay @=> s @=> players[16];
    s.load( "../data/kick.wav" );
    new SoundPlay @=> s @=> players[17];
    s.load( "../data/hihat.wav" );

    new SonOfClickty @=> players[22];
    new ClicktyPlay @=> players[23];

    // global patch
    JCRev rev[channels];
    Gain all_rev;
    for( int i; i < channels; i++ )
    {
        .001 => rev[i].mix;
        // rev[i] => dac.chan(i);
        all_rev => rev[i];
    }

    // volume
    float volumes[players.cap()];
    float rates[players.cap()];
    // last time
    time last_time;

    // play drum
    fun void play( int which, int channel, float vol, float pitch )
    {
        // sanity check
        if( which < 0 || which >= players.cap() )
        {
            <<< "error: illegal play index:", which, " | max:", players.cap() >>>;
            return;
        }

        // <<< "play:", which, channel, vol, pitch >>>;

        // check time
        if( now != last_time )
        {
            // clear volume
            for( int i; i < volumes.cap();i ++ )
                0.0 => volumes[i];
            // remember time
            now => last_time;
        }

        if( channel >= 0 )
        {
            // make channel safe
            channel % channels => channel;
            // connect sound
            players[which].connect( dac.chan(channel) );
        }
        else // all channels
        {
            players[which].connect( dac );
        }

        // play
        if( vol > volumes[which] )
        {
            vol => volumes[which];
            pitch => rates[which];
        }

        players[which].play( volumes[which], rates[which] );
    }
}
