// name: SoundPlay.ck
// desc: drum trigger

// the SoundPlay class
public class SoundPlay extends Play
{
    // the sndbuf
    SndBuf buffy;

    // load
    fun void load( string path )
    { path => buffy.read; }

    // start
    fun void connect( UGen out )
    {
        // sever if needed
        if( m_init ) sever();
        buffy => out;
        0 => buffy.gain;
        out @=> m_out;
        true => m_init;
    }

    // stop
    fun void sever()
    { if( m_init ) { buffy =< m_out; false => m_init; } }

    // play
    fun void play( float vol, float rate )
    {
        if( !m_init ) return;
        0 => buffy.pos;
        vol => buffy.gain;
        rate => buffy.rate;
    }

    // set note
    fun float note( float note )
    { note => buffy.rate; return note; }
    // get note
    fun float note() { return buffy.rate(); }

    // set volume
    fun float vol( float v ) { v => buffy.gain; return v; }
    // get volume
    fun float vol() { return buffy.gain(); }
}
