
// network switchboard
public class SwitchBoard
{
    // number of targets
    1 => int targets;
    // send objects
    OscSend xmit[12];
    // port
    6449 => int port;

    // aim the transmitter at port
    xmit[0].setHost ( "localhost", port );
    xmit[1].setHost ( "localhost", port );
    xmit[2].setHost ( "localhost", port );
    xmit[3].setHost ( "localhost", port );
    xmit[4].setHost ( "localhost", port );

    // hack!
    SoundBank bank;

    // play
    fun void play( int which, int channel, float vol, float pitch, int host )
    {
        if( host >= targets )
        {
            <<< "invalid host number:", host >>>;
            return;
        }

        // start the message...
        xmit[host].startMsg( "/manamana/play", "i i f f" );

        // a message is kicked as soon as it is complete
        which => xmit[host].addInt;
        channel => xmit[host].addInt;
        vol => xmit[host].addFloat;
        pitch => xmit[host].addFloat;
    }

    // listen
    fun void listen()
    {
        // create our OSC receiver
        OscRecv recv;
        // use port 6449
        6449 => recv.port;
        // start listening (launch thread)
        recv.listen();

        // create an address in the receiver, store in new variable
        recv.event( "/manamana/play, i i f f" ) @=> OscEvent oe;

        // count
        int which;
        int channel;
        float vol;
        float pitch;

        // infinite event loop
        while ( true )
        {
            // wait for event to arrive
            oe => now;

            // grab the next message from the queue. 
            while( oe.nextMsg() != 0 )
            {
                // get which
                oe.getInt() => which;
                oe.getInt() => channel;
                oe.getFloat() => vol;
                oe.getFloat() => pitch;

                // do something
                bank.play( which, channel, vol, pitch );
            }
        }
    }
}
